 /* Petit programme pour afficher une VALEUR inférieure à 10.000.000 avec les
   points de séparation des puissances de 1000 et des espaces en tête pour avoir
   toujours 9 caractères affichés. Ce programme fonctionne sur la ligne série USB
   et permet de vérifier l'organigramme en vue de la versions pour LCD. */

// Variables du programme.   
unsigned long VALEUR = 2000000; // Valeur numérique de la donnée à afficher.
boolean ESPACE; // Signale qu'il faut compléter avec des espaces et non des "0".
unsigned int PAQUET; // Valeur numérique comprise entre 0 et 999.

void setup() {Serial.begin(115200); Serial.println(); Serial.println();
  Serial.println(">>> Affichage d'une VALEUR avec FORMAT. <<<"); Serial.println(); }
  
void loop() {  if (VALEUR == 0) {INFINI();} Affiche_VALEUR_avec_formatage();
  VALEUR = VALEUR - 100; } // Incrémenter de 100 pour arriver "rapidement" au MAXI.
  
void INFINI() {
  Serial.println(); Serial.println("Passage en boucle INFINIE.");
  ICI: goto ICI;} // Boucle infinie.
 
//@@@@@@@@@@@@@@@ Ci-dessous code à ajouter au programme utilisateur @@@@@@@@@@@@@@@

/* Variables à introduire dans le programme en cours de développement :   
unsigned long VALEUR = 0; // Valeur numérique de la donnée à afficher.
boolean ESPACE; // Signale qu'il faut compléter avec des espaces et non des "0".
unsigned int PAQUET; // Valeur numérique comprise entre 0 et 999. */
  
void COMPLETER() {if (ESPACE) {Serial.print(" ");} else {Serial.print("0");} } 
  
void Afficher_un_PAQUET() {// Valeur comprise entre 0 et 999.
  if (PAQUET < 100) {COMPLETER();} // Afficher un espace ou un zéro.
  if (PAQUET < 10) {COMPLETER();}  // Afficher un autre espace ou un autre zéro.
  if (PAQUET == 0) {COMPLETER();} else {Serial.print(PAQUET);} }

void Affiche_VALEUR_avec_formatage() {
  // Formate l'affichage pour placer les points et les espaces en tête pour
  // 9 caractères. Ne modifie pas la variable VALEUR.
  unsigned long SAV_VALEUR = VALEUR; boolean Mega_non_nul;
  ESPACE = true; // Commencer par des espaces si valeur insuffisante.
  /*>>>>>>>>>>>>>>>>>>>>>>>>>>>> Afficher les MEGA <<<<<<<<<<<<<<<<<<<<<<<<<<<*/
  PAQUET = VALEUR / 1000000; // Isoler les Méga dans PAQUET et VALEUR inchangée.
  // Si > 0 afficher les Méga suivi d'un point, si non afficher deux espaces.
  if (PAQUET == 0) {Serial.print("  "); Mega_non_nul = false;}
      else {Serial.print(PAQUET); Serial.print("."); ESPACE = false; Mega_non_nul = true;
            // Enlever les MEGA déjà affichés dans VALEUR :
            VALEUR = VALEUR - (PAQUET * 1000000); }
  /*>>>>>>>>>>>>>>>>>>>>>>>>>>>> Afficher les KILO <<<<<<<<<<<<<<<<<<<<<<<<<<<*/
  PAQUET = VALEUR / 1000; // Isoler les KILO dans PAQUET et VALEUR inchangée.
  Afficher_un_PAQUET();
  if ((PAQUET > 0) | (Mega_non_nul))
     {Serial.print("."); ESPACE = false;} else {Serial.print(" "); } 
  /*>>>>>>>>>>>>>>>>>>>>>>>>>>> Afficher les UNITÉS <<<<<<<<<<<<<<<<<<<<<<<<<<*/
  // Enlever les KILO déjà affichés à VALEUR.
  if (PAQUET > 0) {PAQUET = VALEUR - (PAQUET * 1000);} else {PAQUET = VALEUR;}
  if ((PAQUET == 0) && (ESPACE)) {Serial.print("  0");} else {Afficher_un_PAQUET();}
  VALEUR = SAV_VALEUR; Serial.println(); }
  
