/* Petit programme qui gère un B.P. avec antirebonds.
   Chaque action sur A0 inverse l'état de la LED 13. */
   
// Constantes utilisées.
#define LED_ARDUINO 13
#define NB_tests_antirebonds 50 // Nombre de tests de stabilisation.

// Variables utilisées.
boolean Clic_sur_le_BP;

void setup(){pinMode( LED_ARDUINO, OUTPUT);
  digitalWrite(LED_ARDUINO, HIGH); }

void loop(){
  Tester_le_BP_A0(); 
  if (Clic_sur_le_BP) // Inverse l'état de la LED d'Arduino.
     {digitalWrite(LED_ARDUINO,!digitalRead(LED_ARDUINO)); Clic_sur_le_BP = false;} }
     
// >>>>>>>>>>>>> Le B.P. est câblé en logique positive <<<<<<<<<<<<<<<<<<  
void Tester_le_BP_A0() { // La lecture sur A0 donne 0 ou 1023.
  byte COMPTEUR;
  if (analogRead(0) > 512){Clic_sur_le_BP = true;
    // Attendre_la_stabilisation à "1".
    COMPTEUR = 0;
    while (COMPTEUR < NB_tests_antirebonds) {
      COMPTEUR++; if (analogRead(0) < 512) {COMPTEUR = 0;} }
    // Attendre_la_stabilisation à "0".
    COMPTEUR = 0;
    while (COMPTEUR < NB_tests_antirebonds) {
      COMPTEUR++; if (analogRead(0) > 512) {COMPTEUR = 0;} } } }
     
// >>>>>>>>>>>>> Le B.P. est câblé en logique négative <<<<<<<<<<<<<<<<<<
/*
void Tester_le_BP_A0() { // La lecture sur A0 donne 0 ou 1023.
  byte COMPTEUR;
  if (analogRead(0) < 512){Clic_sur_le_BP = true; 
    // Attendre_la_stabilisation à "0".
    COMPTEUR = 0;
    while (COMPTEUR < NB_tests_antirebonds) {
      COMPTEUR++; if (analogRead(0) > 512) {COMPTEUR = 0;} }
    // Attendre_la_stabilisation à "1".
    COMPTEUR = 0;
    while (COMPTEUR < NB_tests_antirebonds) {
      COMPTEUR++; if (analogRead(0) < 512) {COMPTEUR = 0;} } } }
*/

