/*  Ohmmètre sur ligne série USB.
 Ce programme est un clone du logiciel 01 mais modifié pour mesurer de fortes valeurs.
 A2 est reliée au +5Vcc par 100 kohms. Calibre 20k ohms à 10 M ohms. */

#define Mesure100K 2 // Entrée analogique 2 utilisée.
#define N 400 // Nombre de mesures pour faire une moyenne.

float Tension_lue;
float Resistance, Ancienne_valeur;

float N_Tensions_lues; // Valeur cumulée.

void setup() {
  Serial.begin(115200);
  Serial.print("  >>>> Mesure de "); Affiche_le_mot_resistance();
  Serial.print("s <<<<");
  Serial.println(); Serial.println(); }

void loop() {
  // Mesures sur A2 avec résistance de limitation de 1000 ohms.
  N_mesures_sur_A2();
  Resistance = Tension_lue * 100000 / (5000 - Tension_lue);
  if (Tension_lue < 4960)
     {Affiche_la_valeur_de_la_resistance();} } // N'affiche que si changée.
  
 void N_mesures_sur_A2() { 
   N_Tensions_lues = 0;
   for (int I = 0; I < (N) ; I++) 
       {Tension_lue = analogRead(Mesure100K); // Mesure analogique [0 à 1023].
       N_Tensions_lues = N_Tensions_lues + Tension_lue; }
       Realise_la_moyenne(); }
       
 void Realise_la_moyenne() {        
  Tension_lue = N_Tensions_lues / N;
  Tension_lue = map(Tension_lue, 0, 1023, 0, 5000); // Tension en volts * 1000.
  if (Tension_lue == 5000) {Tension_lue = 4999.99;} }
  // 4999.99 au lieu de 5000 pour viter une division par zéro dans le calcul de R. 
  
 void Affiche_le_mot_resistance() {
   Serial.print("R"); Serial.print(char (233)); Serial.print("sistance");}
 
 void Affiche_la_valeur_de_la_resistance() {  
  if (Resistance != Ancienne_valeur) {
  Ancienne_valeur = Resistance;
  Serial.print("  Tension lue = ");
  Serial.print(Tension_lue/1000,3); Serial.print("   ");
  Affiche_le_mot_resistance(); Serial.print(" sur A2 = "); Serial.println(Resistance,0); } }
   
