/* Programme élémentaire de comptage sans prise en compte des débordements.
   Dans cette version le compteur recycle sans fin de 65535 à zéro. */

#define Entree_Compteur 5 // Entrée D5 pour servira aussi pour mesurer les fréquences.

// Variable du programme.
unsigned long COMPTEUR, Ancienne_Valeur;

void setup() {
  Serial.begin(115200); pinMode(Entree_Compteur, INPUT);}

void loop() {Serial.println(); Serial.println("FONCTION COMPTEUR.");
  RAZ_COMPTEUR();
  TCCR1A = 0;   // Le Timer 1 est configuré en simple compteur.
  // 111 pour Source externe sur D5 et comptage sur le front montant :
  TCCR1B = (1<<CS12) | (1<<CS11) | (1<<CS10);
  INFINI:
  //========================= Traiter le COMPTEUR ===============================
  // Ci-dessous une première lecture fait passer TCNT1H dans le TAMPON.
  COMPTEUR = TCNT1L;
  // Lecture des 16 bits dans la variable COMPTEUR.
  COMPTEUR = TCNT1;
  // ============================================================================
  if(COMPTEUR != Ancienne_Valeur) {
  Serial.print(" CMPT = "); Serial.println(COMPTEUR); Ancienne_Valeur = COMPTEUR;}
  goto INFINI; }
  
void RAZ_COMPTEUR() {
  COMPTEUR = 0; Ancienne_Valeur = 1; // Pour forcer l'affichage; 
  // Replacer le compteur à zéro pour une nouvelle mesure.
  // Attention en écriture il faut commencer par les poids forts pour charger le TAMPON.
  TCNT1H = 0; TCNT1L = 0;}
